DECLARE @primaryCultureId UNIQUEIDENTIFIER;
DECLARE @maxIndex INT = (SELECT ISNULL(MAX([Index]), -1) FROM [dbo].[SysCulture]);

IF (OBJECT_ID('tempdb..#IncorrectCultures') IS NOT NULL)
	DROP TABLE #IncorrectCultures;
CREATE TABLE #IncorrectCultures (Id UNIQUEIDENTIFIER);

SELECT TOP (1)
	@primaryCultureId = ssv.GuidValue
FROM [dbo].[SysSettings] ss
	INNER JOIN [dbo].[SysSettingsValue] ssv ON ss.Id = ssv.SysSettingsId
		WHERE ss.Code = 'PrimaryCulture';

INSERT INTO #IncorrectCultures
SELECT
	[Id]
FROM [dbo].[SysCulture]
	WHERE [Id] <> @primaryCultureId
		AND [Index] = 0;

UPDATE [dbo].[SysCulture]
SET @maxIndex = [Index] = @maxIndex + 1
FROM #IncorrectCultures
	JOIN [dbo].[SysCulture] ON [dbo].[SysCulture].[Id] = #IncorrectCultures.[Id];
