-- DEFINE TABLE WITH NEW-OLD ID'S PAIRS
CREATE TABLE #TEMP_ID_TBL (
	IDNEW UNIQUEIDENTIFIER,
	IDOLD UNIQUEIDENTIFIER
)

CREATE TABLE #TEMP_CURRENT_DASHBOARDS_ID_TBL (
	IDNEW UNIQUEIDENTIFIER,
	IDOLD UNIQUEIDENTIFIER
)

INSERT INTO #TEMP_ID_TBL
VALUES
	('6586e67e-38b1-4d26-93f1-ae5b563d611d', 'b5fdb1eb-14a4-445d-b1ca-8820ec3949b0'),
	('09e9debf-7038-4957-9dca-bebaaa21bddd', '658c1d38-9072-4721-8f2d-814d2c6027bf'),
	('b08d189d-1d37-4266-983c-8820d8b91cfd', '5d610361-a781-4548-9e28-2a45c2839c5f'),
	('a71d5c04-dff7-4892-90e5-9e7cc2246915', '61996483-d076-4a47-a770-d1df0b22fa64'),
	('6cd83a1c-ef8b-42a6-a152-1074118a34d5', '5bfb951d-7df2-4b78-bfac-e70dbe4a4ac3'),
	('c27f96fe-e3e3-42ad-9e50-e4a2b754cee1', '86c02e62-1311-4540-acfc-12d9b8cdea5f')


-- SAVE NEW LOCALIZATIONS
INSERT INTO #TEMP_CURRENT_DASHBOARDS_ID_TBL
SELECT [t].[IDNEW], [d].[Id] FROM [dbo].[SysDashboard] AS [d]
	INNER JOIN [#TEMP_ID_TBL] AS [t] ON [t].[IDOLD] = [d].[Id];

SELECT * 
INTO #NEWIDS_DASHBOARDS_LCZ_TEMP_TBL
FROM SYSDASHBOARDLCZ
WHERE RECORDID IN (SELECT IDNEW FROM #TEMP_CURRENT_DASHBOARDS_ID_TBL)

DELETE [d]
FROM [dbo].[SysDashboard] AS [d]
	INNER JOIN [#TEMP_CURRENT_DASHBOARDS_ID_TBL] AS [t] ON [t].[IDNEW] = [d].[Id];

--MOVE DATA FROM LCZ AND RIGHTS TO TEMP TABLES 
SELECT * 
INTO #DASHBOARDS_RIGHTS_TEMP_TBL
FROM SYSDASHBOARDRIGHT
WHERE RECORDID IN (SELECT IDOLD FROM #TEMP_CURRENT_DASHBOARDS_ID_TBL)

DELETE FROM SYSDASHBOARDRIGHT
WHERE RECORDID IN (SELECT IDOLD FROM #TEMP_CURRENT_DASHBOARDS_ID_TBL)

SELECT * 
INTO #DASHBOARDS_LCZ_TEMP_TBL
FROM SYSDASHBOARDLCZ
WHERE RECORDID IN (SELECT IDOLD FROM #TEMP_CURRENT_DASHBOARDS_ID_TBL)

DELETE FROM SYSDASHBOARDLCZ
WHERE RECORDID IN (SELECT IDOLD FROM #TEMP_CURRENT_DASHBOARDS_ID_TBL)

--UPDATE ID'S
UPDATE SYSDASHBOARD
    SET 
	   ID = IDNEW
FROM SYSDASHBOARD
INNER JOIN #TEMP_CURRENT_DASHBOARDS_ID_TBL 
    ON #TEMP_CURRENT_DASHBOARDS_ID_TBL.IDOLD = SYSDASHBOARD.ID

UPDATE #DASHBOARDS_RIGHTS_TEMP_TBL
    SET 
	   #DASHBOARDS_RIGHTS_TEMP_TBL.RECORDID = #TEMP_CURRENT_DASHBOARDS_ID_TBL.IDNEW
FROM #DASHBOARDS_RIGHTS_TEMP_TBL
INNER JOIN #TEMP_CURRENT_DASHBOARDS_ID_TBL 
    ON #TEMP_CURRENT_DASHBOARDS_ID_TBL.IDOLD = #DASHBOARDS_RIGHTS_TEMP_TBL.RECORDID

UPDATE #DASHBOARDS_LCZ_TEMP_TBL
    SET 
	   #DASHBOARDS_LCZ_TEMP_TBL.RECORDID = #TEMP_CURRENT_DASHBOARDS_ID_TBL.IDNEW
FROM #DASHBOARDS_LCZ_TEMP_TBL
INNER JOIN #TEMP_CURRENT_DASHBOARDS_ID_TBL 
    ON #TEMP_CURRENT_DASHBOARDS_ID_TBL.IDOLD = #DASHBOARDS_LCZ_TEMP_TBL.RECORDID

INSERT INTO SYSDASHBOARDRIGHT
SELECT * FROM #DASHBOARDS_RIGHTS_TEMP_TBL

INSERT INTO SYSDASHBOARDLCZ
SELECT * FROM #DASHBOARDS_LCZ_TEMP_TBL

--INSERT NEW LOCALIZATIONS IF OLD HAVENT EXISTED
MERGE INTO SYSDASHBOARDLCZ sdl
   USING (SELECT RecordId, Items, Caption, SysCultureId, ModifiedOn FROM #NEWIDS_DASHBOARDS_LCZ_TEMP_TBL) sdlTemp
ON (sdl.RecordId = sdlTemp.RecordId)
WHEN NOT MATCHED 
	THEN INSERT (RecordId, Items, Caption, SysCultureId, ModifiedOn)
		VALUES (sdlTemp.RecordId, sdlTemp.Items, sdlTemp.Caption, sdlTemp.SysCultureId, sdlTemp.ModifiedOn);


DROP TABLE #DASHBOARDS_LCZ_TEMP_TBL
DROP TABLE #NEWIDS_DASHBOARDS_LCZ_TEMP_TBL
DROP TABLE #DASHBOARDS_RIGHTS_TEMP_TBL
DROP TABLE #TEMP_ID_TBL
DROP TABLE #TEMP_CURRENT_DASHBOARDS_ID_TBL